Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_ecckd_interface.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_ecckd_interface.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_ecckd_interface.F90	(revision 4853)
@@ -39,5 +39,5 @@
     if (lhook) call dr_hook('radiation_ecckd_interface:setup_gas_optics',0,hook_handle)
 
-    if (config%do_sw) then
+    if (config%do_sw .and. config%i_gas_model_sw == IGasModelECCKD) then
 
       ! Read shortwave ecCKD gas optics NetCDF file
@@ -57,16 +57,7 @@
       end if
 
-!      if (allocated(config%i_band_from_g_sw)) deallocate(config%i_band_from_g_sw)
-!      allocate(config%i_band_from_g_sw(config%n_g_sw))
-!      if (allocated(config%i_band_from_reordered_g_sw)) deallocate(config%i_band_from_reordered_g_sw)
-!      allocate(config%i_band_from_reordered_g_sw(config%n_g_sw))
-!      if (allocated(config%i_g_from_reordered_g_sw)) deallocate(config%i_g_from_reordered_g_sw)
-!      allocate(config%i_g_from_reordered_g_sw(config%n_g_sw))
-      if (.not.allocated(config%i_band_from_g_sw)) &
-              allocate(config%i_band_from_g_sw(config%n_g_sw))
-      if (.not.allocated(config%i_band_from_reordered_g_sw)) &
-              allocate(config%i_band_from_reordered_g_sw(config%n_g_sw))
-      if (.not.allocated(config%i_g_from_reordered_g_sw)) &
-              allocate(config%i_g_from_reordered_g_sw(config%n_g_sw))
+      allocate(config%i_band_from_g_sw          (config%n_g_sw))
+      allocate(config%i_band_from_reordered_g_sw(config%n_g_sw))
+      allocate(config%i_g_from_reordered_g_sw   (config%n_g_sw))
         
       if (config%do_cloud_aerosol_per_sw_g_point) then
@@ -93,5 +84,5 @@
     end if
 
-    if (config%do_lw) then
+    if (config%do_lw .and. config%i_gas_model_lw == IGasModelECCKD) then
 
       ! Read longwave ecCKD gas optics NetCDF file
@@ -111,17 +102,7 @@
       end if
 
-!      if (allocated(config%i_band_from_g_lw)) deallocate(config%i_band_from_g_lw)
-!      allocate(config%i_band_from_g_lw          (config%n_g_lw))
-!      if (allocated(config%i_band_from_reordered_g_lw)) deallocate(config%i_band_from_reordered_g_lw)
-!      allocate(config%i_band_from_reordered_g_lw(config%n_g_lw))
-!      if (allocated(config%i_g_from_reordered_g_lw)) deallocate(config%i_g_from_reordered_g_lw)
-!      allocate(config%i_g_from_reordered_g_lw   (config%n_g_lw))
-      if (.not.allocated(config%i_band_from_g_lw)) &
-         allocate(config%i_band_from_g_lw          (config%n_g_lw))
-      if (.not.allocated(config%i_band_from_reordered_g_lw)) &
-         allocate(config%i_band_from_reordered_g_lw(config%n_g_lw))
-      if (.not.allocated(config%i_g_from_reordered_g_lw)) &
-         allocate(config%i_g_from_reordered_g_lw   (config%n_g_lw))
-
+      allocate(config%i_band_from_g_lw          (config%n_g_lw))
+      allocate(config%i_band_from_reordered_g_lw(config%n_g_lw))
+      allocate(config%i_g_from_reordered_g_lw   (config%n_g_lw))
 
       if (config%do_cloud_aerosol_per_lw_g_point) then
@@ -199,5 +180,5 @@
     use yomhook,  only : lhook, dr_hook, jphook
 
-    use radiation_config,         only : config_type
+    use radiation_config,         only : config_type, IGasModelECCKD
     use radiation_thermodynamics, only : thermodynamics_type
     use radiation_single_level,   only : single_level_type
@@ -242,5 +223,9 @@
     real(jprb) :: temperature_fl(istartcol:iendcol,nlev)
 
-    integer :: jcol
+    real(jprb) :: concentration_scaling(NMaxGases)
+    
+    logical :: is_volume_mixing_ratio
+    
+    integer :: jcol, jlev, jg
 
     real(jphook) :: hook_handle
@@ -259,19 +244,40 @@
          &  / (thermodynamics%pressure_hl(istartcol:iendcol,1:nlev) &
          &    +thermodynamics%pressure_hl(istartcol:iendcol,2:nlev+1))
- 
-    if (config%do_sw) then
-
-      call config%gas_optics_sw%calc_optical_depth(ncol,nlev,istartcol,iendcol, &
-           &  NMaxGases, thermodynamics%pressure_hl, &
-           &  temperature_fl, &
-           &  gas%mixing_ratio, &
-!           &  reshape(gas%mixing_ratio(istartcol:iendcol,:,:), &
-!           &          [nlev,iendcol-istartcol+1,NMaxGases],order=[2,1,3]), &
-           &  od_sw, rayleigh_od_fl=ssa_sw)
+
+    ! Check that the gas concentrations are stored in volume mixing
+    ! ratio with no scaling; if not, return a vector of scalings
+    call gas%assert_units(IVolumeMixingRatio, scale_factor=1.0_jprb, &
+         &                istatus=is_volume_mixing_ratio)
+    if (.not. is_volume_mixing_ratio) then
+      call gas%get_scaling(IVolumeMixingRatio, concentration_scaling)
+    else
+      concentration_scaling = 1.0_jprb
+    end if
+    
+    if (config%do_sw .and. config%i_gas_model_sw == IGasModelECCKD) then
+
+      if (is_volume_mixing_ratio) then
+        call config%gas_optics_sw%calc_optical_depth(ncol,nlev,istartcol,iendcol, &
+             &  NMaxGases, thermodynamics%pressure_hl, &
+             &  temperature_fl, gas%mixing_ratio, &
+             &  od_sw, rayleigh_od_fl=ssa_sw)
+      else
+        call config%gas_optics_sw%calc_optical_depth(ncol,nlev,istartcol,iendcol, &
+             &  NMaxGases, thermodynamics%pressure_hl, &
+             &  temperature_fl, gas%mixing_ratio, &
+             &  od_sw, rayleigh_od_fl=ssa_sw, concentration_scaling=concentration_scaling)
+      end if
+      
       ! At this point od_sw = absorption optical depth and ssa_sw =
       ! rayleigh optical depth: convert to total optical depth and
       ! single-scattering albedo
-      od_sw = od_sw + ssa_sw
-      ssa_sw = ssa_sw / od_sw
+      do jcol = istartcol,iendcol
+        do jlev = 1, nlev
+          do jg = 1, config%n_g_sw
+            od_sw(jg,jlev,jcol)  = od_sw(jg,jlev,jcol) + ssa_sw(jg,jlev,jcol)
+            ssa_sw(jg,jlev,jcol) = ssa_sw(jg,jlev,jcol) / od_sw(jg,jlev,jcol)
+          end do
+        end do
+      end do
 
       if (present(incoming_sw)) then
@@ -287,13 +293,17 @@
     end if
 
-    if (config%do_lw) then
-
-      call config%gas_optics_lw%calc_optical_depth(ncol,nlev,istartcol,iendcol, &
-           &  NMaxGases, thermodynamics%pressure_hl, &
-           &  temperature_fl, &
-           &  gas%mixing_ratio, &
-!           &  reshape(gas%mixing_ratio(istartcol:iendcol,:,:), &
-!           &          [nlev,iendcol-istartcol+1,NMaxGases],order=[2,1,3]), &
-           &  od_lw)
+    if (config%do_lw .and. config%i_gas_model_lw == IGasModelECCKD) then
+
+      if (is_volume_mixing_ratio) then
+        call config%gas_optics_lw%calc_optical_depth(ncol,nlev,istartcol,iendcol, &
+             &  NMaxGases, thermodynamics%pressure_hl, &
+             &  temperature_fl, gas%mixing_ratio, &
+             &  od_lw)
+      else
+        call config%gas_optics_lw%calc_optical_depth(ncol,nlev,istartcol,iendcol, &
+             &  NMaxGases, thermodynamics%pressure_hl, &
+             &  temperature_fl, gas%mixing_ratio, &
+             &  od_lw, concentration_scaling=concentration_scaling)
+      end if
 
       ! Calculate the Planck function for each g point
@@ -305,4 +315,5 @@
            &  single_level%skin_temperature(istartcol:iendcol), &
            &  lw_emission(:,:))
+!NEC$ forced_collapse
       lw_emission = lw_emission * (1.0_jprb - lw_albedo)
 
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_flux.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_flux.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_flux.F90	(revision 4853)
@@ -20,4 +20,6 @@
 !   2021-01-20  R. Hogan  Added heating_rate_out_of_physical_bounds function
 !   2022-12-07  R. Hogan  Added top-of-atmosphere spectral output
+
+#include "ecrad_config.h"
 
 module radiation_flux
@@ -117,5 +119,5 @@
 
 ! Added for DWD (2020)
-#ifdef __SX__
+#ifdef DWD_VECTOR_OPTIMIZATIONS
       logical, parameter :: use_indexed_sum_vec = .true.
 #else
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_gas.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_gas.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_gas.F90	(revision 4853)
@@ -72,4 +72,5 @@
      procedure :: assert_units => assert_units_gas
      procedure :: get        => get_gas
+     procedure :: get_scaling
      procedure :: reverse    => reverse_gas
      procedure :: out_of_physical_bounds
@@ -355,5 +356,5 @@
     real(jprb), optional, intent(in)    :: scale_factor
 
-    integer :: ig
+    integer :: jg
 
     ! Scaling factor to convert from old to new
@@ -396,6 +397,6 @@
       end if
     else
-      do ig = 1,this%ntype
-        call this%set_units(iunits, igas=this%icode(ig), scale_factor=new_sf)
+      do jg = 1,this%ntype
+        call this%set_units(iunits, igas=this%icode(jg), scale_factor=new_sf)
       end do
     end if
@@ -403,21 +404,46 @@
   end subroutine set_units_gas
 
-
+  
+  !---------------------------------------------------------------------
+  ! Return a vector indicating the scaling that one would need to
+  ! apply to each gas in order to obtain the dimension units in
+  ! "iunits" (which can be IVolumeMixingRatio or IMassMixingRatio)
+  subroutine get_scaling(this, iunits, scaling)
+    class(gas_type), intent(in)  :: this
+    integer,         intent(in)  :: iunits
+    real(jprb),      intent(out) :: scaling(NMaxGases)
+    integer :: jg
+    
+    scaling = this%scale_factor
+    do jg = 1,NMaxGases
+      if (iunits == IMassMixingRatio .and. this%iunits(jg) == IVolumeMixingRatio) then
+        scaling(jg) = scaling(jg) * GasMolarMass(jg) / AirMolarMass
+      else if (iunits == IVolumeMixingRatio .and. this%iunits(jg) == IMassMixingRatio) then
+        scaling(jg) = scaling(jg) * AirMolarMass / GasMolarMass(jg)
+      end if
+    end do
+    
+  end subroutine get_scaling
+
+  
   !---------------------------------------------------------------------
   ! Assert that gas mixing ratio units are "iunits", applying to gas
   ! with ID "igas" if present, otherwise to all gases. Otherwise the
-  ! program will exit. Otional argument scale factor specifies any
-  ! subsequent multiplication to apply; for PPMV one would use
-  ! iunits=IVolumeMixingRatio and scale_factor=1.0e6.
-  recursive subroutine assert_units_gas(this, iunits, igas, scale_factor)
+  ! program will exit, except if the optional argument "istatus" is
+  ! provided in which case it will return true if the units are
+  ! correct and false if they are not. Optional argument scale factor
+  ! specifies any subsequent multiplication to apply; for PPMV one
+  ! would use iunits=IVolumeMixingRatio and scale_factor=1.0e6.
+  recursive subroutine assert_units_gas(this, iunits, igas, scale_factor, istatus)
 
     use radiation_io,   only : nulerr, radiation_abort
 
-    class(gas_type),      intent(in) :: this
-    integer,              intent(in) :: iunits
-    integer,    optional, intent(in) :: igas
-    real(jprb), optional, intent(in) :: scale_factor
-
-    integer :: ig
+    class(gas_type),      intent(in)  :: this
+    integer,              intent(in)  :: iunits
+    integer,    optional, intent(in)  :: igas
+    real(jprb), optional, intent(in)  :: scale_factor
+    logical,    optional, intent(out) :: istatus
+
+    integer :: jg
 
     real(jprb) :: sf
@@ -429,20 +455,32 @@
     end if
 
+    if (present(istatus)) then
+      istatus = .true.
+    end if
+    
     if (present(igas)) then
       if (this%is_present(igas)) then
         if (iunits /= this%iunits(igas)) then
-          write(nulerr,'(a,a,a)') '*** Error: ', trim(GasName(igas)), &
-               &  ' is not in the required units'
-          call radiation_abort()
+          if (present(istatus)) then
+            istatus = .false.
+          else
+            write(nulerr,'(a,a,a)') '*** Error: ', trim(GasName(igas)), &
+                 &  ' is not in the required units'
+            call radiation_abort()
+          end if
         else if (sf /= this%scale_factor(igas)) then
-          write(nulerr,'(a,a,a,e12.4,a,e12.4)') '*** Error: ', GasName(igas), &
-               &  ' scaling of ', this%scale_factor(igas), &
-               &  ' does not match required ', sf
-          call radiation_abort()
+          if (present(istatus)) then
+            istatus = .false.
+          else
+            write(nulerr,'(a,a,a,e12.4,a,e12.4)') '*** Error: ', GasName(igas), &
+                 &  ' scaling of ', this%scale_factor(igas), &
+                 &  ' does not match required ', sf
+            call radiation_abort()
+          end if
         end if
       end if
     else
-      do ig = 1,this%ntype
-        call this%assert_units(iunits, igas=this%icode(ig), scale_factor=sf)
+      do jg = 1,this%ntype
+        call this%assert_units(iunits, igas=this%icode(jg), scale_factor=sf, istatus=istatus)
       end do
     end if
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_general_cloud_optics.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_general_cloud_optics.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_general_cloud_optics.F90	(revision 4853)
@@ -75,10 +75,8 @@
     ! Allocate structures
     if (config%do_sw) then
-      if (allocated(config%cloud_optics_sw)) deallocate(config%cloud_optics_sw)      
       allocate(config%cloud_optics_sw(config%n_cloud_types))
     end if
 
     if (config%do_lw) then
-      if (allocated(config%cloud_optics_lw)) deallocate(config%cloud_optics_lw)      
       allocate(config%cloud_optics_lw(config%n_cloud_types))
     end if
@@ -172,5 +170,5 @@
     real(jprb), dimension(istartcol:iendcol,nlev) :: water_path
 
-    integer :: jtype, jcol, jlev
+    integer :: jtype, jcol, jlev, jg
 
     real(jphook) :: hook_handle
@@ -275,8 +273,10 @@
           if (cloud%fraction(jcol,jlev) > 0.0_jprb) then
             ! Scale to get asymmetry factor and single scattering albedo
-            g_sw_cloud(:,jlev,jcol) = g_sw_cloud(:,jlev,jcol) &
-                 &  / max(ssa_sw_cloud(:,jlev,jcol), 1.0e-15_jprb)
-            ssa_sw_cloud(:,jlev,jcol) = ssa_sw_cloud(:,jlev,jcol) &
-                 &  / max(od_sw_cloud(:,jlev,jcol),  1.0e-15_jprb)
+            do jg = 1, config%n_bands_sw
+              g_sw_cloud(jg,jlev,jcol) = g_sw_cloud(jg,jlev,jcol) &
+                 &  / max(ssa_sw_cloud(jg,jlev,jcol), 1.0e-15_jprb)
+              ssa_sw_cloud(jg,jlev,jcol) = ssa_sw_cloud(jg,jlev,jcol) &
+                 &  / max(od_sw_cloud(jg,jlev,jcol),  1.0e-15_jprb)
+            end do
           end if
         end do
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_general_cloud_optics_data.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_general_cloud_optics_data.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_general_cloud_optics_data.F90	(revision 4853)
@@ -15,4 +15,6 @@
 !
 
+#include "ecrad_config.h"
+
 module radiation_general_cloud_optics_data
 
@@ -73,5 +75,9 @@
 
     use yomhook,                       only : lhook, dr_hook, jphook
-    use easy_netcdf,                   only : netcdf_file
+#ifdef EASY_NETCDF_READ_MPI
+    use easy_netcdf_read_mpi, only : netcdf_file
+#else
+    use easy_netcdf,          only : netcdf_file
+#endif
     use radiation_spectral_definition, only : spectral_definition_type
     use radiation_io,                  only : nulout, nulerr, radiation_abort
@@ -181,8 +187,4 @@
 
     ! Thin averaging
-
-    ! Circumvent ifort bug (see https://github.com/ecmwf-ifs/ecrad/issues/13):
-    allocate(this%mass_ext(size(mapping, 1), nre))
-
     this%mass_ext  = matmul(mapping, mass_ext)
     this%ssa       = matmul(mapping, mass_ext*ssa) / this%mass_ext
@@ -267,10 +269,10 @@
          &     scat_asymmetry ! Scattering optical depth x asymmetry factor
 
-    real(jprb) :: od_local(ng)
+    real(jprb) :: od_local
 
     real(jprb) :: re_index, weight1, weight2
     integer :: ire
 
-    integer :: jcol, jlev
+    integer :: jcol, jlev, jg
 
     real(jphook) :: hook_handle
@@ -287,13 +289,16 @@
             weight2 = re_index - ire
             weight1 = 1.0_jprb - weight2
-            od_local = water_path(jcol, jlev) * (weight1*this%mass_ext(:,ire) &
-                 &                              +weight2*this%mass_ext(:,ire+1))
-            od(:,jlev,jcol) = od(:,jlev,jcol) + od_local
-            od_local = od_local * (weight1*this%ssa(:,ire) &
-                 &                +weight2*this%ssa(:,ire+1))
-            scat_od(:,jlev,jcol) = scat_od(:,jlev,jcol) + od_local
-            scat_asymmetry(:,jlev,jcol) = scat_asymmetry(:,jlev,jcol) &
-                 & + od_local * (weight1*this%asymmetry(:,ire) &
-                 &              +weight2*this%asymmetry(:,ire+1))
+            do jg = 1, ng
+              od_local = water_path(jcol, jlev) * (weight1*this%mass_ext(jg,ire) &
+                 &                                +weight2*this%mass_ext(jg,ire+1))
+              od(jg,jlev,jcol) = od(jg,jlev,jcol) + od_local
+              od_local = od_local * (weight1*this%ssa(jg,ire) &
+                 &                  +weight2*this%ssa(jg,ire+1))
+              scat_od(jg,jlev,jcol) = scat_od(jg,jlev,jcol) + od_local
+              scat_asymmetry(jg,jlev,jcol) = scat_asymmetry(jg,jlev,jcol) &
+                 & + od_local * (weight1*this%asymmetry(jg,ire) &
+                 &              +weight2*this%asymmetry(jg,ire+1))
+            end do
+
           end if
         end do
